'use strict';

var _objectSpread = require('@babel/runtime/helpers/objectSpread2');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var accounts = require('permissionless/accounts');
var accountAbstraction = require('viem/account-abstraction');
var constants = require('./constants.js');

class TrustSmartAccount {
  constructor(options) {
    _defineProperty(this, "name", constants.SMART_ACCOUNT.TRUST);
    _defineProperty(this, "options", void 0);
    this.options = options;
  }
  async getSmartAccount(params) {
    var _this$options, _this$options2;
    return accounts.toTrustSmartAccount(_objectSpread(_objectSpread(_objectSpread({}, this.options || {}), {}, {
      entryPoint: {
        address: ((_this$options = this.options) === null || _this$options === void 0 || (_this$options = _this$options.entryPoint) === null || _this$options === void 0 ? void 0 : _this$options.address) || accountAbstraction.entryPoint06Address,
        version: ((_this$options2 = this.options) === null || _this$options2 === void 0 || (_this$options2 = _this$options2.entryPoint) === null || _this$options2 === void 0 ? void 0 : _this$options2.version) || "0.6"
      }
    }, params), {}, {
      owner: params.owner,
      client: params.client
    }));
  }
}

exports.TrustSmartAccount = TrustSmartAccount;
