import { IProvider } from "@web3auth/base";
import { ToBiconomySmartAccountParameters } from "permissionless/accounts";
import { Client } from "viem";
import { SmartAccount } from "viem/account-abstraction";
import { BiconomySmartAccountConfig, ISmartAccount } from "./types";
export declare class BiconomySmartAccount implements ISmartAccount {
    readonly name: string;
    options: BiconomySmartAccountConfig;
    constructor(options?: BiconomySmartAccountConfig);
    getSmartAccount(params: {
        owner: IProvider;
        client: Client;
    } & Pick<ToBiconomySmartAccountParameters, "index" | "nonceKey" | "address">): Promise<SmartAccount>;
}
