import { IProvider } from "@web3auth/base";
import { Client } from "viem";
import { SmartAccount } from "viem/account-abstraction";
import { ISmartAccount, KernelSmartAccountConfig, KernelSmartAccountParameters } from "./types";
export declare class KernelSmartAccount implements ISmartAccount {
    readonly name: string;
    options: KernelSmartAccountConfig;
    constructor(options?: KernelSmartAccountConfig);
    getSmartAccount(params: {
        owner: IProvider;
        client: Client;
    } & Pick<KernelSmartAccountParameters, "address" | "nonceKey" | "index">): Promise<SmartAccount>;
}
