import { IProvider } from "@web3auth/base";
import { ToLightSmartAccountParameters } from "permissionless/accounts";
import { Client } from "viem";
import { SmartAccount } from "viem/account-abstraction";
import { ISmartAccount, LightSmartAccountConfig } from "./types";
export declare class LightSmartAccount implements ISmartAccount {
    readonly name: string;
    options: LightSmartAccountConfig;
    constructor(options?: LightSmartAccountConfig);
    getSmartAccount(params: {
        owner: IProvider;
        client: Client;
    } & Pick<ToLightSmartAccountParameters, "address" | "index" | "nonceKey">): Promise<SmartAccount>;
}
