import { IProvider } from "@web3auth/base";
import { ToNexusSmartAccountParameters } from "permissionless/accounts";
import { Client } from "viem";
import { SmartAccount } from "viem/account-abstraction";
import { ISmartAccount, NexusSmartAccountConfig } from "./types";
export declare class NexusSmartAccount implements ISmartAccount {
    readonly name: string;
    options: NexusSmartAccountConfig;
    constructor(options?: NexusSmartAccountConfig);
    getSmartAccount(params: {
        owner: IProvider;
        client: Client;
    } & Pick<ToNexusSmartAccountParameters, "index" | "address">): Promise<SmartAccount>;
}
