import { IProvider } from "@web3auth/base";
import { Client } from "viem";
import { SmartAccount } from "viem/account-abstraction";
import { ISmartAccount, SafeSmartAccountConfig, SafeSmartAccountParameters } from "./types";
export declare class SafeSmartAccount implements ISmartAccount {
    readonly name: string;
    options: SafeSmartAccountConfig;
    constructor(options?: SafeSmartAccountConfig);
    getSmartAccount(params: {
        owner: IProvider;
        client: Client;
    } & Pick<SafeSmartAccountParameters, "address" | "nonceKey" | "saltNonce" | "validUntil" | "validAfter">): Promise<SmartAccount>;
}
