import { IProvider } from "@web3auth/base";
import { Client } from "viem";
import { SmartAccount } from "viem/account-abstraction";
import { ISmartAccount, TrustSmartAccountConfig, TrustSmartAccountParameters } from "./types";
export declare class TrustSmartAccount implements ISmartAccount {
    readonly name: string;
    options: TrustSmartAccountConfig;
    constructor(options?: TrustSmartAccountConfig);
    getSmartAccount(params: {
        owner: IProvider;
        client: Client;
    } & Pick<TrustSmartAccountParameters, "address" | "nonceKey" | "index">): Promise<SmartAccount>;
}
